diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/theme.php ./wordpress-3.4/wp-includes/theme.php
*** ./wordpress-3.3.2/wp-includes/theme.php	2011-11-14 17:56:18.000000000 -0600
--- ./wordpress-3.4/wp-includes/theme.php	2012-06-12 10:57:11.000000000 -0500
***************
*** 571,1120 ****
   *
   * @since 2.9.0
   *
   * @return array Valid themes found
   */
! function search_theme_directories() {
! 	global $wp_theme_directories, $wp_broken_themes;
  	if ( empty( $wp_theme_directories ) )
  		return false;
  
! 	$theme_files = array();
! 	$wp_broken_themes = array();
! 
! 	/* Loop the registered theme directories and extract all themes */
! 	foreach ( (array) $wp_theme_directories as $theme_root ) {
! 		$theme_loc = $theme_root;
! 
! 		/* We don't want to replace all forward slashes, see Trac #4541 */
! 		if ( '/' != WP_CONTENT_DIR )
! 			$theme_loc = str_replace(WP_CONTENT_DIR, '', $theme_root);
! 
! 		/* Files in the root of the current theme directory and one subdir down */
! 		$themes_dir = @ opendir($theme_root);
! 
! 		if ( !$themes_dir )
! 			return false;
  
! 		while ( ($theme_dir = readdir($themes_dir)) !== false ) {
! 			if ( is_dir($theme_root . '/' . $theme_dir) && is_readable($theme_root . '/' . $theme_dir) ) {
! 				if ( $theme_dir[0] == '.' || $theme_dir == 'CVS' )
  					continue;
! 
! 				$stylish_dir = @opendir($theme_root . '/' . $theme_dir);
! 				$found_stylesheet = false;
! 
! 				while ( ($theme_file = readdir($stylish_dir)) !== false ) {
! 					if ( $theme_file == 'style.css' ) {
! 						$theme_files[$theme_dir] = array( 'theme_file' => $theme_dir . '/' . $theme_file, 'theme_root' => $theme_root );
! 						$found_stylesheet = true;
! 						break;
! 					}
! 				}
! 				@closedir($stylish_dir);
! 
! 				if ( !$found_stylesheet ) { // look for themes in that dir
! 					$subdir = "$theme_root/$theme_dir";
! 					$subdir_name = $theme_dir;
! 					$theme_subdirs = @opendir( $subdir );
! 
! 					$found_subdir_themes = false;
! 					while ( ($theme_subdir = readdir($theme_subdirs)) !== false ) {
! 						if ( is_dir( $subdir . '/' . $theme_subdir) && is_readable($subdir . '/' . $theme_subdir) ) {
! 							if ( $theme_subdir[0] == '.' || $theme_subdir == 'CVS' )
! 								continue;
! 
! 							$stylish_dir = @opendir($subdir . '/' . $theme_subdir);
! 							$found_stylesheet = false;
! 
! 							while ( ($theme_file = readdir($stylish_dir)) !== false ) {
! 								if ( $theme_file == 'style.css' ) {
! 									$theme_files["$theme_dir/$theme_subdir"] = array( 'theme_file' => $subdir_name . '/' . $theme_subdir . '/' . $theme_file, 'theme_root' => $theme_root );
! 									$found_stylesheet = true;
! 									$found_subdir_themes = true;
! 									break;
! 								}
! 							}
! 							@closedir($stylish_dir);
! 						}
! 					}
! 					@closedir($theme_subdirs);
! 					if ( !$found_subdir_themes )
! 						$wp_broken_themes[$theme_dir] = array('Name' => $theme_dir, 'Title' => $theme_dir, 'Description' => __('Stylesheet is missing.'));
! 				}
  			}
  		}
! 		@closedir( $themes_dir );
! 	}
! 	return $theme_files;
! }
! 
! /**
!  * Retrieve path to themes directory.
!  *
!  * Does not have trailing slash.
!  *
!  * @since 1.5.0
!  * @uses apply_filters() Calls 'theme_root' filter on path.
!  *
!  * @param string $stylesheet_or_template The stylesheet or template name of the theme
!  * @return string Theme path.
!  */
! function get_theme_root( $stylesheet_or_template = false ) {
! 	if ( $stylesheet_or_template ) {
! 		if ( $theme_root = get_raw_theme_root($stylesheet_or_template) )
! 			$theme_root = WP_CONTENT_DIR . $theme_root;
! 		else
! 			$theme_root = WP_CONTENT_DIR . '/themes';
! 	} else {
! 		$theme_root = WP_CONTENT_DIR . '/themes';
! 	}
! 
! 	return apply_filters( 'theme_root', $theme_root );
! }
! 
! /**
!  * Retrieve URI for themes directory.
!  *
!  * Does not have trailing slash.
!  *
!  * @since 1.5.0
!  *
!  * @param string $stylesheet_or_template The stylesheet or template name of the theme
!  * @return string Themes URI.
!  */
! function get_theme_root_uri( $stylesheet_or_template = false ) {
! 	if ( $stylesheet_or_template ) {
! 		if ( $theme_root = get_raw_theme_root($stylesheet_or_template) )
! 			$theme_root_uri = content_url( $theme_root );
! 		else
! 			$theme_root_uri = content_url( 'themes' );
  	} else {
! 		$theme_root_uri = content_url( 'themes' );
  	}
  
! 	return apply_filters( 'theme_root_uri', $theme_root_uri, get_option('siteurl'), $stylesheet_or_template );
! }
! 
! /**
!  * Get the raw theme root relative to the content directory with no filters applied.
!  *
!  * @since 3.1.0
!  *
!  * @param string $stylesheet_or_template The stylesheet or template name of the theme
!  * @return string Theme root
!  */
! function get_raw_theme_root( $stylesheet_or_template, $no_cache = false ) {
! 	global $wp_theme_directories;
! 
! 	if ( count($wp_theme_directories) <= 1 )
! 		return '/themes';
! 
! 	$theme_root = false;
! 
! 	// If requesting the root for the current theme, consult options to avoid calling get_theme_roots()
! 	if ( !$no_cache ) {
! 		if ( get_option('stylesheet') == $stylesheet_or_template )
! 			$theme_root = get_option('stylesheet_root');
! 		elseif ( get_option('template') == $stylesheet_or_template )
! 			$theme_root = get_option('template_root');
! 	}
! 
! 	if ( empty($theme_root) ) {
! 		$theme_roots = get_theme_roots();
! 		if ( !empty($theme_roots[$stylesheet_or_template]) )
! 			$theme_root = $theme_roots[$stylesheet_or_template];
! 	}
! 
! 	return $theme_root;
! }
! 
! /**
!  * Retrieve path to a template
!  *
!  * Used to quickly retrieve the path of a template without including the file
!  * extension. It will also check the parent theme, if the file exists, with
!  * the use of {@link locate_template()}. Allows for more generic template location
!  * without the use of the other get_*_template() functions.
!  *
!  * @since 1.5.0
!  *
!  * @param string $type Filename without extension.
!  * @param array $templates An optional list of template candidates
!  * @return string Full path to file.
!  */
! function get_query_template( $type, $templates = array() ) {
! 	$type = preg_replace( '|[^a-z0-9-]+|', '', $type );
! 
! 	if ( empty( $templates ) )
! 		$templates = array("{$type}.php");
! 
! 	return apply_filters( "{$type}_template", locate_template( $templates ) );
! }
! 
! /**
!  * Retrieve path of index template in current or parent template.
!  *
!  * @since 3.0.0
!  *
!  * @return string
!  */
! function get_index_template() {
! 	return get_query_template('index');
! }
! 
! /**
!  * Retrieve path of 404 template in current or parent template.
!  *
!  * @since 1.5.0
!  *
!  * @return string
!  */
! function get_404_template() {
! 	return get_query_template('404');
! }
! 
! /**
!  * Retrieve path of archive template in current or parent template.
!  *
!  * @since 1.5.0
!  *
!  * @return string
!  */
! function get_archive_template() {
! 	$post_type = get_query_var( 'post_type' );
! 
! 	$templates = array();
! 
! 	if ( $post_type )
! 		$templates[] = "archive-{$post_type}.php";
! 	$templates[] = 'archive.php';
! 
! 	return get_query_template( 'archive', $templates );
! }
! 
! /**
!  * Retrieve path of author template in current or parent template.
!  *
!  * @since 1.5.0
!  *
!  * @return string
!  */
! function get_author_template() {
! 	$author = get_queried_object();
! 
! 	$templates = array();
! 
! 	$templates[] = "author-{$author->user_nicename}.php";
! 	$templates[] = "author-{$author->ID}.php";
! 	$templates[] = 'author.php';
! 
! 	return get_query_template( 'author', $templates );
! }
! 
! /**
!  * Retrieve path of category template in current or parent template.
!  *
!  * Works by first retrieving the current slug for example 'category-default.php' and then
!  * trying category ID, for example 'category-1.php' and will finally fallback to category.php
!  * template, if those files don't exist.
!  *
!  * @since 1.5.0
!  * @uses apply_filters() Calls 'category_template' on file path of category template.
!  *
!  * @return string
!  */
! function get_category_template() {
! 	$category = get_queried_object();
! 
! 	$templates = array();
! 
! 	$templates[] = "category-{$category->slug}.php";
! 	$templates[] = "category-{$category->term_id}.php";
! 	$templates[] = 'category.php';
! 
! 	return get_query_template( 'category', $templates );
! }
! 
! /**
!  * Retrieve path of tag template in current or parent template.
!  *
!  * Works by first retrieving the current tag name, for example 'tag-wordpress.php' and then
!  * trying tag ID, for example 'tag-1.php' and will finally fallback to tag.php
!  * template, if those files don't exist.
!  *
!  * @since 2.3.0
!  * @uses apply_filters() Calls 'tag_template' on file path of tag template.
!  *
!  * @return string
!  */
! function get_tag_template() {
! 	$tag = get_queried_object();
! 
! 	$templates = array();
! 
! 	$templates[] = "tag-{$tag->slug}.php";
! 	$templates[] = "tag-{$tag->term_id}.php";
! 	$templates[] = 'tag.php';
! 
! 	return get_query_template( 'tag', $templates );
! }
! 
! /**
!  * Retrieve path of taxonomy template in current or parent template.
!  *
!  * Retrieves the taxonomy and term, if term is available. The template is
!  * prepended with 'taxonomy-' and followed by both the taxonomy string and
!  * the taxonomy string followed by a dash and then followed by the term.
!  *
!  * The taxonomy and term template is checked and used first, if it exists.
!  * Second, just the taxonomy template is checked, and then finally, taxonomy.php
!  * template is used. If none of the files exist, then it will fall back on to
!  * index.php.
!  *
!  * @since 2.5.0
!  * @uses apply_filters() Calls 'taxonomy_template' filter on found path.
!  *
!  * @return string
!  */
! function get_taxonomy_template() {
! 	$term = get_queried_object();
! 	$taxonomy = $term->taxonomy;
! 
! 	$templates = array();
! 
! 	$templates[] = "taxonomy-$taxonomy-{$term->slug}.php";
! 	$templates[] = "taxonomy-$taxonomy.php";
! 	$templates[] = 'taxonomy.php';
! 
! 	return get_query_template( 'taxonomy', $templates );
! }
! 
! /**
!  * Retrieve path of date template in current or parent template.
!  *
!  * @since 1.5.0
!  *
!  * @return string
!  */
! function get_date_template() {
! 	return get_query_template('date');
! }
! 
! /**
!  * Retrieve path of home template in current or parent template.
!  *
!  * This is the template used for the page containing the blog posts
!  *
!  * Attempts to locate 'home.php' first before falling back to 'index.php'.
!  *
!  * @since 1.5.0
!  * @uses apply_filters() Calls 'home_template' on file path of home template.
!  *
!  * @return string
!  */
! function get_home_template() {
! 	$templates = array( 'home.php', 'index.php' );
! 
! 	return get_query_template( 'home', $templates );
! }
! 
! /**
!  * Retrieve path of front-page template in current or parent template.
!  *
!  * Looks for 'front-page.php'.
!  *
!  * @since 3.0.0
!  * @uses apply_filters() Calls 'front_page_template' on file path of template.
!  *
!  * @return string
!  */
! function get_front_page_template() {
! 	$templates = array('front-page.php');
! 
! 	return get_query_template( 'front_page', $templates );
! }
! 
! /**
!  * Retrieve path of page template in current or parent template.
!  *
!  * Will first look for the specifically assigned page template
!  * The will search for 'page-{slug}.php' followed by 'page-id.php'
!  * and finally 'page.php'
!  *
!  * @since 1.5.0
!  *
!  * @return string
!  */
! function get_page_template() {
! 	$id = get_queried_object_id();
! 	$template = get_post_meta($id, '_wp_page_template', true);
! 	$pagename = get_query_var('pagename');
! 
! 	if ( !$pagename && $id > 0 ) {
! 		// If a static page is set as the front page, $pagename will not be set. Retrieve it from the queried object
! 		$post = get_queried_object();
! 		$pagename = $post->post_name;
! 	}
! 
! 	if ( 'default' == $template )
! 		$template = '';
! 
! 	$templates = array();
! 	if ( !empty($template) && !validate_file($template) )
! 		$templates[] = $template;
! 	if ( $pagename )
! 		$templates[] = "page-$pagename.php";
! 	if ( $id )
! 		$templates[] = "page-$id.php";
! 	$templates[] = 'page.php';
! 
! 	return get_query_template( 'page', $templates );
! }
! 
! /**
!  * Retrieve path of paged template in current or parent template.
!  *
!  * @since 1.5.0
!  *
!  * @return string
!  */
! function get_paged_template() {
! 	return get_query_template('paged');
! }
  
! /**
!  * Retrieve path of search template in current or parent template.
!  *
!  * @since 1.5.0
!  *
!  * @return string
!  */
! function get_search_template() {
! 	return get_query_template('search');
! }
  
! /**
!  * Retrieve path of single template in current or parent template.
!  *
!  * @since 1.5.0
!  *
!  * @return string
!  */
! function get_single_template() {
! 	$object = get_queried_object();
  
! 	$templates = array();
  
! 	$templates[] = "single-{$object->post_type}.php";
! 	$templates[] = "single.php";
  
! 	return get_query_template( 'single', $templates );
! }
  
! /**
!  * Retrieve path of attachment template in current or parent template.
!  *
!  * The attachment path first checks if the first part of the mime type exists.
!  * The second check is for the second part of the mime type. The last check is
!  * for both types separated by an underscore. If neither are found then the file
!  * 'attachment.php' is checked and returned.
!  *
!  * Some examples for the 'text/plain' mime type are 'text.php', 'plain.php', and
!  * finally 'text_plain.php'.
!  *
!  * @since 2.0.0
!  *
!  * @return string
!  */
! function get_attachment_template() {
! 	global $posts;
! 	$type = explode('/', $posts[0]->post_mime_type);
! 	if ( $template = get_query_template($type[0]) )
! 		return $template;
! 	elseif ( $template = get_query_template($type[1]) )
! 		return $template;
! 	elseif ( $template = get_query_template("$type[0]_$type[1]") )
! 		return $template;
! 	else
! 		return get_query_template('attachment');
  }
  
  /**
!  * Retrieve path of comment popup template in current or parent template.
   *
!  * Checks for comment popup template in current template, if it exists or in the
!  * parent template.
   *
   * @since 1.5.0
!  * @uses apply_filters() Calls 'comments_popup_template' filter on path.
   *
!  * @return string
   */
! function get_comments_popup_template() {
! 	$template = get_query_template( 'comments_popup', array( 'comments-popup.php' ) );
  
! 	// Backward compat code will be removed in a future release
! 	if ('' == $template)
! 		$template = ABSPATH . WPINC . '/theme-compat/comments-popup.php';
  
! 	return $template;
  }
  
  /**
!  * Retrieve the name of the highest priority template file that exists.
   *
!  * Searches in the STYLESHEETPATH before TEMPLATEPATH so that themes which
!  * inherit from a parent theme can just overload one file.
   *
!  * @since 2.7.0
   *
!  * @param string|array $template_names Template file(s) to search for, in order.
!  * @param bool $load If true the template file will be loaded if it is found.
!  * @param bool $require_once Whether to require_once or require. Default true. Has no effect if $load is false.
!  * @return string The template filename if one is located.
   */
! function locate_template($template_names, $load = false, $require_once = true ) {
! 	$located = '';
! 	foreach ( (array) $template_names as $template_name ) {
! 		if ( !$template_name )
! 			continue;
! 		if ( file_exists(STYLESHEETPATH . '/' . $template_name)) {
! 			$located = STYLESHEETPATH . '/' . $template_name;
! 			break;
! 		} else if ( file_exists(TEMPLATEPATH . '/' . $template_name) ) {
! 			$located = TEMPLATEPATH . '/' . $template_name;
! 			break;
  		}
  	}
  
! 	if ( $load && '' != $located )
! 		load_template( $located, $require_once );
! 
! 	return $located;
  }
  
  /**
!  * Require the template file with WordPress environment.
!  *
!  * The globals are set up for the template file to ensure that the WordPress
!  * environment is available from within the function. The query variables are
!  * also available.
   *
!  * @since 1.5.0
   *
!  * @param string $_template_file Path to template file.
!  * @param bool $require_once Whether to require_once or require. Default true.
   */
! function load_template( $_template_file, $require_once = true ) {
! 	global $posts, $post, $wp_did_header, $wp_did_template_redirect, $wp_query, $wp_rewrite, $wpdb, $wp_version, $wp, $id, $comment, $user_ID;
  
! 	if ( is_array( $wp_query->query_vars ) )
! 		extract( $wp_query->query_vars, EXTR_SKIP );
  
! 	if ( $require_once )
! 		require_once( $_template_file );
! 	else
! 		require( $_template_file );
  }
  
  /**
--- 310,520 ----
   *
   * @since 2.9.0
   *
+  * @param bool $force Optional. Whether to force a new directory scan. Defaults to false.
   * @return array Valid themes found
   */
! function search_theme_directories( $force = false ) {
! 	global $wp_theme_directories;
  	if ( empty( $wp_theme_directories ) )
  		return false;
  
! 	static $found_themes;
! 	if ( ! $force && isset( $found_themes ) )
! 		return $found_themes;
! 
! 	$found_themes = array();
! 
! 	$wp_theme_directories = (array) $wp_theme_directories;
! 
! 	// Set up maybe-relative, maybe-absolute array of theme directories.
! 	// We always want to return absolute, but we need to cache relative
! 	// use in for get_theme_root().
! 	foreach ( $wp_theme_directories as $theme_root ) {
! 		if ( 0 === strpos( $theme_root, WP_CONTENT_DIR ) )
! 			$relative_theme_roots[ str_replace( WP_CONTENT_DIR, '', $theme_root ) ] = $theme_root;
! 		else
! 			$relative_theme_roots[ $theme_root ] = $theme_root;
! 	}
  
! 	if ( $cache_expiration = apply_filters( 'wp_cache_themes_persistently', false, 'search_theme_directories' ) ) {
! 		$cached_roots = get_site_transient( 'theme_roots' );
! 		if ( is_array( $cached_roots ) ) {
! 			foreach ( $cached_roots as $theme_dir => $theme_root ) {
! 				// A cached theme root is no longer around, so skip it.
! 				if ( ! isset( $relative_theme_roots[ $theme_root ] ) )
  					continue;
! 				$found_themes[ $theme_dir ] = array(
! 					'theme_file' => $theme_dir . '/style.css',
! 					'theme_root' => $relative_theme_roots[ $theme_root ], // Convert relative to absolute.
! 				);
  			}
+ 			return $found_themes;
  		}
! 		if ( ! is_int( $cache_expiration ) )
! 			$cache_expiration = 1800; // half hour
  	} else {
! 		$cache_expiration = 1800; // half hour
  	}
  
! 	/* Loop the registered theme directories and extract all themes */
! 	foreach ( $wp_theme_directories as $theme_root ) {
  
! 		// Start with directories in the root of the current theme directory.
! 		$dirs = @ scandir( $theme_root );
! 		if ( ! $dirs )
! 			return false;
! 		foreach ( $dirs as $dir ) {
! 			if ( ! is_dir( $theme_root . '/' . $dir ) || $dir[0] == '.' || $dir == 'CVS' )
! 				continue;
! 			if ( file_exists( $theme_root . '/' . $dir . '/style.css' ) ) {
! 				// wp-content/themes/a-single-theme
! 				// wp-content/themes is $theme_root, a-single-theme is $dir
! 				$found_themes[ $dir ] = array(
! 					'theme_file' => $dir . '/style.css',
! 					'theme_root' => $theme_root,
! 				);
! 			} else {
! 				$found_theme = false;
! 				// wp-content/themes/a-folder-of-themes/*
! 				// wp-content/themes is $theme_root, a-folder-of-themes is $dir, then themes are $sub_dirs
! 				$sub_dirs = @ scandir( $theme_root . '/' . $dir );
! 				if ( ! $sub_dirs )
! 					return false;
! 				foreach ( $sub_dirs as $sub_dir ) {
! 					if ( ! is_dir( $theme_root . '/' . $dir ) || $dir[0] == '.' || $dir == 'CVS' )
! 						continue;
! 					if ( ! file_exists( $theme_root . '/' . $dir . '/' . $sub_dir . '/style.css' ) )
! 						continue;
! 					$found_themes[ $dir . '/' . $sub_dir ] = array(
! 						'theme_file' => $dir . '/' . $sub_dir . '/style.css',
! 						'theme_root' => $theme_root,
! 					);
! 					$found_theme = true;
! 				}
! 				// Never mind the above, it's just a theme missing a style.css.
! 				// Return it; WP_Theme will catch the error.
! 				if ( ! $found_theme )
! 					$found_themes[ $dir ] = array(
! 						'theme_file' => $dir . '/style.css',
! 						'theme_root' => $theme_root,
! 					);
! 			}
! 		}
! 	}
  
! 	asort( $found_themes );
  
! 	$theme_roots = array();
! 	$relative_theme_roots = array_flip( $relative_theme_roots );
  
! 	foreach ( $found_themes as $theme_dir => $theme_data ) {
! 		$theme_roots[ $theme_dir ] = $relative_theme_roots[ $theme_data['theme_root'] ]; // Convert absolute to relative.
! 	}
  
! 	if ( $theme_roots != get_site_transient( 'theme_roots' ) )
! 		set_site_transient( 'theme_roots', $theme_roots, $cache_expiration );
  
! 	return $found_themes;
  }
  
  /**
!  * Retrieve path to themes directory.
   *
!  * Does not have trailing slash.
   *
   * @since 1.5.0
!  * @uses apply_filters() Calls 'theme_root' filter on path.
   *
!  * @param string $stylesheet_or_template The stylesheet or template name of the theme
!  * @return string Theme path.
   */
! function get_theme_root( $stylesheet_or_template = false ) {
! 	global $wp_theme_directories;
  
! 	if ( $stylesheet_or_template && $theme_root = get_raw_theme_root( $stylesheet_or_template ) ) {
! 		// Always prepend WP_CONTENT_DIR unless the root currently registered as a theme directory.
! 		// This gives relative theme roots the benefit of the doubt when things go haywire.
! 		if ( ! in_array( $theme_root, (array) $wp_theme_directories ) )
! 			$theme_root = WP_CONTENT_DIR . $theme_root;
! 	} else {
! 		$theme_root = WP_CONTENT_DIR . '/themes';
! 	}
  
! 	return apply_filters( 'theme_root', $theme_root );
  }
  
  /**
!  * Retrieve URI for themes directory.
   *
!  * Does not have trailing slash.
   *
!  * @since 1.5.0
   *
!  * @param string $stylesheet_or_template Optional. The stylesheet or template name of the theme.
!  * 	Default is to leverage the main theme root.
!  * @param string $theme_root Optional. The theme root for which calculations will be based, preventing
!  * 	the need for a get_raw_theme_root() call.
!  * @return string Themes URI.
   */
! function get_theme_root_uri( $stylesheet_or_template = false, $theme_root = false ) {
! 	global $wp_theme_directories;
! 
! 	if ( $stylesheet_or_template && ! $theme_root )
! 		$theme_root = get_raw_theme_root( $stylesheet_or_template );
! 
! 	if ( $stylesheet_or_template && $theme_root ) {
! 		if ( in_array( $theme_root, (array) $wp_theme_directories ) ) {
! 			// Absolute path. Make an educated guess. YMMV -- but note the filter below.
! 			if ( 0 === strpos( $theme_root, WP_CONTENT_DIR ) )
! 				$theme_root_uri = content_url( str_replace( WP_CONTENT_DIR, '', $theme_root ) );
! 			elseif ( 0 === strpos( $theme_root, ABSPATH ) )
! 				$theme_root_uri = site_url( str_replace( ABSPATH, '', $theme_root ) );
! 			elseif ( 0 === strpos( $theme_root, WP_PLUGIN_DIR ) || 0 === strpos( $theme_root, WPMU_PLUGIN_DIR ) )
! 				$theme_root_uri = plugins_url( basename( $theme_root ), $theme_root );
! 			else
! 				$theme_root_uri = $theme_root;
! 		} else {
! 			$theme_root_uri = content_url( $theme_root );
  		}
+ 	} else {
+ 		$theme_root_uri = content_url( 'themes' );
  	}
  
! 	return apply_filters( 'theme_root_uri', $theme_root_uri, get_option('siteurl'), $stylesheet_or_template );
  }
  
  /**
!  * Get the raw theme root relative to the content directory with no filters applied.
   *
!  * @since 3.1.0
   *
!  * @param string $stylesheet_or_template The stylesheet or template name of the theme
!  * @param bool $skip_cache Optional. Whether to skip the cache. Defaults to false, meaning the cache is used.
!  * @return string Theme root
   */
! function get_raw_theme_root( $stylesheet_or_template, $skip_cache = false ) {
! 	global $wp_theme_directories;
! 
! 	if ( count($wp_theme_directories) <= 1 )
! 		return '/themes';
  
! 	$theme_root = false;
  
! 	// If requesting the root for the current theme, consult options to avoid calling get_theme_roots()
! 	if ( ! $skip_cache ) {
! 		if ( get_option('stylesheet') == $stylesheet_or_template )
! 			$theme_root = get_option('stylesheet_root');
! 		elseif ( get_option('template') == $stylesheet_or_template )
! 			$theme_root = get_option('template_root');
! 	}
! 
! 	if ( empty($theme_root) ) {
! 		$theme_roots = get_theme_roots();
! 		if ( !empty($theme_roots[$stylesheet_or_template]) )
! 			$theme_root = $theme_roots[$stylesheet_or_template];
! 	}
! 
! 	return $theme_root;
  }
  
  /**
***************
*** 1163,1169 ****
  	}
  
  	// Prevent theme mods to current theme being used on theme being previewed
! 	add_filter( 'pre_option_mods_' . get_current_theme(), '__return_empty_array' );
  
  	ob_start( 'preview_theme_ob_filter' );
  }
--- 563,569 ----
  	}
  
  	// Prevent theme mods to current theme being used on theme being previewed
! 	add_filter( 'pre_option_theme_mods_' . get_option( 'stylesheet' ), '__return_empty_array' );
  
  	ob_start( 'preview_theme_ob_filter' );
  }
***************
*** 1231,1237 ****
  	)
  		return $matches[1] . "#$matches[2] onclick=$matches[2]return false;" . $matches[4];
  
! 	$link = add_query_arg( array('preview' => 1, 'template' => $_GET['template'], 'stylesheet' => @$_GET['stylesheet'] ), $matches[3] );
  	if ( 0 === strpos($link, 'preview=1') )
  		$link = "?$link";
  	return $matches[1] . esc_attr( $link ) . $matches[4];
--- 631,637 ----
  	)
  		return $matches[1] . "#$matches[2] onclick=$matches[2]return false;" . $matches[4];
  
! 	$link = add_query_arg( array( 'preview' => 1, 'template' => $_GET['template'], 'stylesheet' => @$_GET['stylesheet'], 'preview_iframe' => 1 ), $matches[3] );
  	if ( 0 === strpos($link, 'preview=1') )
  		$link = "?$link";
  	return $matches[1] . esc_attr( $link ) . $matches[4];
***************
*** 1241,1277 ****
   * Switches current theme to new template and stylesheet names.
   *
   * @since 2.5.0
!  * @uses do_action() Calls 'switch_theme' action on updated theme display name.
   *
   * @param string $template Template name
   * @param string $stylesheet Stylesheet name.
   */
! function switch_theme($template, $stylesheet) {
  	global $wp_theme_directories, $sidebars_widgets;
  
  	if ( is_array( $sidebars_widgets ) )
  		set_theme_mod( 'sidebars_widgets', array( 'time' => time(), 'data' => $sidebars_widgets ) );
  
! 	$old_theme = get_current_theme();
  
! 	update_option('template', $template);
! 	update_option('stylesheet', $stylesheet);
  
! 	if ( count($wp_theme_directories) > 1 ) {
! 		update_option('template_root', get_raw_theme_root($template, true));
! 		update_option('stylesheet_root', get_raw_theme_root($stylesheet, true));
  	}
  
! 	delete_option('current_theme');
! 	$theme = get_current_theme();
  
! 	if ( is_admin() && false === get_option( "theme_mods_$stylesheet" ) ) {
! 		$default_theme_mods = (array) get_option( "mods_$theme" );
  		add_option( "theme_mods_$stylesheet", $default_theme_mods );
  	}
  
! 	update_option( 'theme_switched', $old_theme );
! 	do_action( 'switch_theme', $theme );
  }
  
  /**
--- 641,678 ----
   * Switches current theme to new template and stylesheet names.
   *
   * @since 2.5.0
!  * @uses do_action() Calls 'switch_theme' action, passing the new theme.
   *
   * @param string $template Template name
   * @param string $stylesheet Stylesheet name.
   */
! function switch_theme( $template, $stylesheet ) {
  	global $wp_theme_directories, $sidebars_widgets;
  
  	if ( is_array( $sidebars_widgets ) )
  		set_theme_mod( 'sidebars_widgets', array( 'time' => time(), 'data' => $sidebars_widgets ) );
  
! 	$old_theme  = wp_get_theme();
! 	$new_theme = wp_get_theme( $stylesheet );
! 	$new_name  = $new_theme->get('Name');
  
! 	update_option( 'template', $template );
! 	update_option( 'stylesheet', $stylesheet );
  
! 	if ( count( $wp_theme_directories ) > 1 ) {
! 		update_option( 'template_root', get_raw_theme_root( $template, true ) );
! 		update_option( 'stylesheet_root', get_raw_theme_root( $stylesheet, true ) );
  	}
  
! 	update_option( 'current_theme', $new_name );
  
! 	if ( is_admin() && false === get_option( 'theme_mods_' . $stylesheet ) ) {
! 		$default_theme_mods = (array) get_option( 'mods_' . $new_name );
  		add_option( "theme_mods_$stylesheet", $default_theme_mods );
  	}
  
! 	update_option( 'theme_switched', $old_theme->get_stylesheet() );
! 	do_action( 'switch_theme', $new_name, $new_theme );
  }
  
  /**
***************
*** 1279,1285 ****
   *
   * Does not check the default theme, which is the fallback and should always exist.
   * Will switch theme to the fallback theme if current theme does not validate.
!  * You can use the 'validate_current_theme' filter to return FALSE to
   * disable this functionality.
   *
   * @since 1.5.0
--- 680,686 ----
   *
   * Does not check the default theme, which is the fallback and should always exist.
   * Will switch theme to the fallback theme if current theme does not validate.
!  * You can use the 'validate_current_theme' filter to return false to
   * disable this functionality.
   *
   * @since 1.5.0
***************
*** 1320,1326 ****
  function get_theme_mods() {
  	$theme_slug = get_option( 'stylesheet' );
  	if ( false === ( $mods = get_option( "theme_mods_$theme_slug" ) ) ) {
! 		$theme_name = get_current_theme();
  		$mods = get_option( "mods_$theme_name" ); // Deprecated location.
  		if ( is_admin() && false !== $mods ) {
  			update_option( "theme_mods_$theme_slug", $mods );
--- 721,729 ----
  function get_theme_mods() {
  	$theme_slug = get_option( 'stylesheet' );
  	if ( false === ( $mods = get_option( "theme_mods_$theme_slug" ) ) ) {
! 		$theme_name = get_option( 'current_theme' );
! 		if ( false === $theme_name )
! 			$theme_name = wp_get_theme()->get('Name');
  		$mods = get_option( "mods_$theme_name" ); // Deprecated location.
  		if ( is_admin() && false !== $mods ) {
  			update_option( "theme_mods_$theme_slug", $mods );
***************
*** 1351,1357 ****
  	if ( isset( $mods[ $name ] ) )
  		return apply_filters( "theme_mod_$name", $mods[ $name ] );
  
! 	return apply_filters( "theme_mod_$name", sprintf( $default, get_template_directory_uri(), get_stylesheet_directory_uri() ) );
  }
  
  /**
--- 754,763 ----
  	if ( isset( $mods[ $name ] ) )
  		return apply_filters( "theme_mod_$name", $mods[ $name ] );
  
! 	if ( is_string( $default ) )
! 		$default = sprintf( $default, get_template_directory_uri(), get_stylesheet_directory_uri() );
! 
! 	return apply_filters( "theme_mod_$name", $default );
  }
  
  /**
***************
*** 1404,1424 ****
   */
  function remove_theme_mods() {
  	delete_option( 'theme_mods_' . get_option( 'stylesheet' ) );
! 	delete_option( 'mods_' . get_current_theme() );
  }
  
  /**
   * Retrieve text color for custom header.
   *
   * @since 2.1.0
-  * @uses HEADER_TEXTCOLOR
   *
   * @return string
   */
  function get_header_textcolor() {
! 	$default = defined('HEADER_TEXTCOLOR') ? HEADER_TEXTCOLOR : '';
! 
! 	return get_theme_mod('header_textcolor', $default);
  }
  
  /**
--- 810,832 ----
   */
  function remove_theme_mods() {
  	delete_option( 'theme_mods_' . get_option( 'stylesheet' ) );
! 
! 	// Old style.
! 	$theme_name = get_option( 'current_theme' );
! 	if ( false === $theme_name )
! 		$theme_name = wp_get_theme()->get('Name');
! 	delete_option( 'mods_' . $theme_name );
  }
  
  /**
   * Retrieve text color for custom header.
   *
   * @since 2.1.0
   *
   * @return string
   */
  function get_header_textcolor() {
! 	return get_theme_mod('header_textcolor', get_theme_support( 'custom-header', 'default-text-color' ) );
  }
  
  /**
